#!/usr/bin/python
# -*- coding: utf-8 -*-

import cv2
from numpy import *

def draw_flow(im,flow,step=16):
  """ stepピクセル間隔のサンプル点にオプティカルフローを
      描画する """

  h,w = im.shape[:2]
  y,x = mgrid[int(step/2):h:step,int(step/2):w:step].reshape(2,-1)
  print x
  fx,fy = flow[y,x].T

  # 線分の頂点を作る
  lines = vstack([x,y,x+fx,y+fy]).T.reshape(-1,2,2)
  lines = int32(lines)
  print lines

  # 画像を生成して描画する
  vis = cv2.cvtColor(im,cv2.COLOR_GRAY2BGR)
  for (x1,y1),(x2,y2) in lines:
    cv2.line(vis,(x1,y1),(x2,y2),(0,255,0),1)
    cv2.circle(vis,(x1,y1),1,(0,255,0), -1)
  return vis

# 動画キャプチャを準備する
#cap = cv2.VideoCapture(0)
cap = cv2.VideoCapture('test.avi')

ret,im = cap.read()
prev_gray = cv2.cvtColor(im,cv2.COLOR_BGR2GRAY)

while True:
  # グレースケール画像を取得する
  ret,im = cap.read()
  gray = cv2.cvtColor(im,cv2.COLOR_BGR2GRAY)

  # フローを計算する
  flow = cv2.calcOpticalFlowFarneback(prev_gray,gray,None,0.5,3,15,3,5,1.2,0)
  prev_gray = gray

  # フローのベクトルを描画する
  cv2.imshow('Optical flow',draw_flow(gray,flow))
  if cv2.waitKey(10) == 27:
    break
